// @generated by protobuf-ts 2.9.1
// @generated from protobuf file "encryption.proto" (package "listener", syntax proto3)
// tslint:disable
import type { RpcTransport } from "@protobuf-ts/runtime-rpc";
import type { ServiceInfo } from "@protobuf-ts/runtime-rpc";
import { Encryption } from "./encryption";
import { stackIntercept } from "@protobuf-ts/runtime-rpc";
import type { ExchangeResponse } from "./encryption";
import type { ExchangeRequest } from "./encryption";
import type { UnaryCall } from "@protobuf-ts/runtime-rpc";
import type { RpcOptions } from "@protobuf-ts/runtime-rpc";
/**
 * @generated from protobuf service listener.Encryption
 */
export interface IEncryptionClient {
    /**
     * @generated from protobuf rpc: Exchange(listener.ExchangeRequest) returns (listener.ExchangeResponse);
     */
    exchange(input: ExchangeRequest, options?: RpcOptions): UnaryCall<ExchangeRequest, ExchangeResponse>;
}
/**
 * @generated from protobuf service listener.Encryption
 */
export class EncryptionClient implements IEncryptionClient, ServiceInfo {
    typeName = Encryption.typeName;
    methods = Encryption.methods;
    options = Encryption.options;
    constructor(private readonly _transport: RpcTransport) {
    }
    /**
     * @generated from protobuf rpc: Exchange(listener.ExchangeRequest) returns (listener.ExchangeResponse);
     */
    exchange(input: ExchangeRequest, options?: RpcOptions): UnaryCall<ExchangeRequest, ExchangeResponse> {
        const method = this.methods[0], opt = this._transport.mergeOptions(options);
        return stackIntercept<ExchangeRequest, ExchangeResponse>("unary", this._transport, method, opt, input);
    }
}
